module Beryll_Factory_Design_TOP (
  CLK27M                       ,
  CLK33M                       ,
  CLK50M                       ,
  CLK125M                      ,
  SMA_CLKIN                    ,
  SMA_CLKOUT                   ,
  HSMC_1_CLKIN                 ,
//  HSMC_2_CLKIN                 ,
  HSMC_3_CLKIN                 ,
  HSMC_1_CLKOUT                ,
  HSMC_2_CLKOUT                ,
  HSMC_3_CLKOUT                ,
  DDR3_ODT                     ,
  DDR3_CLK                     ,
  DDR3_CLK_N                   ,
  DDR3_CS_N                    ,
  DDR3_CKE                     ,
  DDR3_ADDR                    ,
  DDR3_BA                      ,
  DDR3_RAS_N                   ,
  DDR3_CAS_N                   ,
  DDR3_WE_N                    ,
  DDR3_DQ                      ,
  DDR3_DQS                     ,
  DDR3_DQS_N                   ,
  DDR3_DM                      ,
  DDR3_RESET_N                 ,
  OCT_RZQIN                    ,
  PUSHSW_N                     ,
  DIPSW                        ,
  LED_N                        ,
  SEVEN_SEG                    ,
  LCD_DATA                     ,
  LCD_E                        ,
  LCD_RS                       ,
  LCD_RW                       ,
  SRAM_WRITE_N                 ,
  SRAM_OE_N                    ,
  SRAM_CS_N                    ,
  SRAM_BE_N                    ,
  FLASH_DATA                   ,
  FLASH_READ_N                 ,
  FLASH_CS_N                   ,
  FLASH_ADDRESS                ,
  FLASH_WRITE_N                ,
  TSE_RX_D                     ,
  TSE_RX_DV                    ,
  TSE_TX_D                     ,
  TSE_TX_EN                    ,
  TSE_RX_CLK                   ,
  TSE_GTX_CLK                  ,
  TSE_MDIO                     ,
  TSE_MDC                      ,
  TSE_RESET_N                  ,
  TSE_MAC_CLK                  ,
  TSE_INTERRUPT_N              ,
  UART_RXD                     ,
  UART_TXD                     ,
  UART_PS_MODE                 ,
  ZB_UART_RXD                  ,
  ZB_UART_TXD                  ,
  ZB_RESET_N                   ,
  ZB_WAKEUP                    ,
  ZB_MODE                      ,
  EZ_CLK                       ,
  EZ_RESET_N                   ,
  EZ_PD                        ,
  EZ_PB                        ,
  EZ_PA                        ,
  EZ_PA7                       ,
  EZ_RDY                       ,
  EZ_CTL                       ,
  EZ_WAKEUP                    ,
  EZ_VBUS_N                    ,
  HSMC_1_DATA                  ,
//  HSMC_2_DATA                  ,
//  HSMC_2_DATAIN                ,
  HSMC_2_DATAOUT               ,
  HSMC_3_DATAIN                ,
  HSMC_3_DATAOUT               ,
  IP_LOCK_DC0                  ,
  IP_LOCK_DD0                  ,
  AUDIO_SYSCLK                 ,
  AUDIO_WS                     ,
  AUDIO_BCK                    ,
  AUDIO_DO                     ,
  AUDIO_DI                     ,
  AUDIO_MC                     ,
  AUDIO_MP                     
//  GX_REFCLK                    ,
//  GX_TXD                       ,
//  GX_RXD                       
);

input  wire        CLK27M;                      //
input  wire        CLK33M;                      //
input  wire        CLK50M;                      //
input  wire        CLK125M;                     //
input  wire        SMA_CLKIN;                   //
output wire        SMA_CLKOUT;                  //
input  wire        HSMC_1_CLKIN;                //
//input  wire        HSMC_2_CLKIN;                //
input  wire        HSMC_3_CLKIN;                //
output wire        HSMC_1_CLKOUT;               //
output wire        HSMC_2_CLKOUT;               //
output wire        HSMC_3_CLKOUT;               //
output wire        DDR3_ODT;                    //
output wire        DDR3_CLK;                    //
output wire        DDR3_CLK_N;                  //
output wire        DDR3_CS_N;                   //
output wire        DDR3_CKE;                    //
output wire [12:0] DDR3_ADDR;                   //
output wire [2:0]  DDR3_BA;                     //
output wire        DDR3_RAS_N;                  //
output wire        DDR3_CAS_N;                  //
output wire        DDR3_WE_N;                   //
inout  wire [15:0] DDR3_DQ;                     //
inout  wire [1:0]  DDR3_DQS;                    //
inout  wire [1:0]  DDR3_DQS_N;                  //
output wire [1:0]  DDR3_DM;                     //
output wire        DDR3_RESET_N;                //
input  wire        OCT_RZQIN;                   //
input  wire [3:0]  PUSHSW_N;                    //
input  wire [3:0]  DIPSW;                       //
output wire [7:0]  LED_N;                       //
output wire [15:0] SEVEN_SEG;                   //
inout  wire [7:0]  LCD_DATA;                    //
output wire        LCD_E;                       //
output wire        LCD_RS;                      //
output wire        LCD_RW;                      //
output wire        SRAM_WRITE_N;                //
output wire        SRAM_OE_N;                   //
output wire        SRAM_CS_N;                   //
output wire [ 1:0] SRAM_BE_N;                   //
inout  wire [15:0] FLASH_DATA;                  //
output wire        FLASH_READ_N;                //
output wire        FLASH_CS_N;                  //
output wire [23:0] FLASH_ADDRESS;               //
output wire        FLASH_WRITE_N;               //
input  wire [3:0]  TSE_RX_D;                    //
input  wire        TSE_RX_DV;                   //
output wire [3:0]  TSE_TX_D;                    //
output wire        TSE_TX_EN;                   //
input  wire        TSE_RX_CLK;                  //
output wire        TSE_GTX_CLK;                 //
inout  wire        TSE_MDIO;                    //
output wire        TSE_MDC;                     //
output wire        TSE_RESET_N;                 //
input  wire        TSE_MAC_CLK;                 //
input  wire        TSE_INTERRUPT_N;             //
input  wire        UART_RXD;                    //
output wire        UART_TXD;                    //
output wire        UART_PS_MODE;                //
input  wire        ZB_UART_RXD;                 //
output wire        ZB_UART_TXD;                 //
output wire        ZB_RESET_N;                  //
output wire        ZB_WAKEUP;                   //
input  wire        ZB_MODE;                     //
input  wire        EZ_CLK;                      //
output wire        EZ_RESET_N;                  //
inout  wire [7:0]  EZ_PD;                       //
inout  wire [7:0]  EZ_PB;                       //
output wire [6:0]  EZ_PA;                       //
input  wire        EZ_PA7;
output wire [1:0]  EZ_RDY;                      //
input  wire [2:0]  EZ_CTL;                      //
output wire        EZ_WAKEUP;                   //
input  wire        EZ_VBUS_N;                   //
output wire [ 5:0] HSMC_1_DATA;                 //
//output wire [ 3:0] HSMC_2_DATA;                 //
//input  wire [ 7:0] HSMC_2_DATAIN;               //
output wire [ 7:0] HSMC_2_DATAOUT;              //
input  wire [ 8:0] HSMC_3_DATAIN;               //
output wire [ 8:0] HSMC_3_DATAOUT;              //
output wire        IP_LOCK_DC0;                 //
output wire        IP_LOCK_DD0;                 //
output wire        AUDIO_SYSCLK;                //
output wire        AUDIO_WS;                    //
output wire        AUDIO_BCK;                   //
output wire        AUDIO_DO;                    //
input  wire        AUDIO_DI;                    //
output wire        AUDIO_MC;                    //
output wire [5:1]  AUDIO_MP;                    //
//input  wire        GX_REFCLK;                   //
//output wire [3:0]  GX_TXD;                      //
//input  wire [3:0]  GX_RXD;                      //

wire        rst_n;
wire        pll_clk100m;
wire        pll_locked;


wire [24:0] tri_address;
assign FLASH_ADDRESS[23:0]            = tri_address[24:1];


//DIRECT connect to DIPSW
assign LED_N[7:4] = DIPSW;
assign LED_N[3] = 1'b1;		//LED isnot used
//DIRECT connect to DIPSW END


cpu_top cpu_top (
 .clk100m_clk                     ( pll_clk100m                   ),
 .reset100m_reset_n               ( rst_n                         ),
 .clk_clk                         ( CLK33M                        ),
 .reset_reset_n                   ( rst_n                         ),
 

 .sram_flash_bus_sram_write_n       (SRAM_WRITE_N                 ),// sram_flash_bus.sram_write_n
 .sram_flash_bus_sram_byte_enable_n (SRAM_BE_N                    ),//               .sram_byte_enable_n
 .sram_flash_bus_sram_read_n        (SRAM_OE_N                    ),//               .sram_read_n
 .sram_flash_bus_sram_cs_n          (SRAM_CS_N                    ),//               .sram_cs_n

 .sram_flash_bus_flash_read_n       (FLASH_READ_N                 ),//               .flash_read_n
 .sram_flash_bus_flash_cs_n         (FLASH_CS_N                   ),//               .flash_cs_n
 .sram_flash_bus_flash_write_n      (FLASH_WRITE_N                ),//               .flash_write_n

 .sram_flash_bus_tri_address        (tri_address                  ),//               .tri_address
 .sram_flash_bus_tri_data           (FLASH_DATA                   ),//               .tri_data

 
 
 .memory_mem_a                    ( DDR3_ADDR                     ),
 .memory_mem_ba                   ( DDR3_BA                       ),
 .memory_mem_ck                   ( DDR3_CLK                      ),
 .memory_mem_ck_n                 ( DDR3_CLK_N                    ),
 .memory_mem_cke                  ( DDR3_CKE                      ),
 .memory_mem_cs_n                 ( DDR3_CS_N                     ),
 .memory_mem_dm                   ( DDR3_DM                       ),
 .memory_mem_ras_n                ( DDR3_RAS_N                    ),
 .memory_mem_cas_n                ( DDR3_CAS_N                    ),
 .memory_mem_we_n                 ( DDR3_WE_N                     ),
 .memory_mem_reset_n              ( DDR3_RESET_N                  ),
 .memory_mem_dq                   ( DDR3_DQ                       ),
 .memory_mem_dqs                  ( DDR3_DQS                      ),
 .memory_mem_dqs_n                ( DDR3_DQS_N                    ),
 .memory_mem_odt                  ( DDR3_ODT                      ),
 .mem_if_status_local_init_done   (                               ),
 .mem_if_status_local_cal_success (                               ),
 .mem_if_status_local_cal_fail    (                               ),
 .oct_rzqin                       ( OCT_RZQIN                     ),
// .led_n_export                    ( LED_N                         ),
 .led_n_export                    (                               ),
 .seven_seg_0_n_export            ( {SEVEN_SEG[7],SEVEN_SEG[6],SEVEN_SEG[5],SEVEN_SEG[4],SEVEN_SEG[3],SEVEN_SEG[2],SEVEN_SEG[1],SEVEN_SEG[0]} ),
 .seven_seg_1_n_export            ( {SEVEN_SEG[15],SEVEN_SEG[14],SEVEN_SEG[13],SEVEN_SEG[12],SEVEN_SEG[11],SEVEN_SEG[10],SEVEN_SEG[9],SEVEN_SEG[8]} ),
 .push_sw_export                  ( PUSHSW_N                      ),
 .dip_sw_export                   ( DIPSW                         ),

//To select LED blink or off according to test result 
 .led_select0_export                (led_select0),                //    led_select0.export
 .led_select1_export                (led_select1),                //    led_select0.export
 .led_select2_export                (led_select2)                 //    led_select0.export

);

pll pll (
  .rst        ( ~rst_n       ),
  .refclk     ( CLK50M       ),
  .outclk_0   ( pll_clk100m  ),
  .locked     ( pll_locked   )
);


//assign rst_n                    = PUSHSW_N[0];
assign rst_n                    = 1'b1;


assign SMA_CLKOUT               = SMA_CLKIN;
assign HSMC_1_CLKOUT            = HSMC_1_CLKIN;
//assign HSMC_2_CLKOUT            = HSMC_2_CLKIN;
assign HSMC_3_CLKOUT            = HSMC_3_CLKIN;
assign HSMC_1_DATA              =  6'b0;
assign HSMC_2_DATA              =  4'b0;
assign HSMC_2_DATAOUT           =  8'b0;
assign HSMC_3_DATAOUT           =  9'b0;
assign IP_LOCK_DC0              =  1'b0;
assign IP_LOCK_DD0              =  1'b0;
assign AUDIO_SYSCLK             =  1'b0;
assign AUDIO_WS                 =  1'b0;
assign AUDIO_BCK                =  1'b0;
assign AUDIO_DO                 =  1'b0;
assign AUDIO_MC                 =  1'b0;
assign AUDIO_MP                 =  5'b0;
assign TSE_TX_D                 =  4'b0;
assign TSE_TX_EN                =  1'b0;
assign TSE_MDIO                 =  1'bz;
assign TSE_MDC                  =  1'b1;
//assign TSE_RESET_N              =  rst_n;
assign TSE_GTX_CLK              =  1'b0;
assign EZ_RESET_N               =  1'b1;
assign EZ_PD                    =  8'b0;
assign EZ_PB                    =  8'b0;
assign EZ_PA                    =  7'b0;
assign EZ_RDY                   =  2'b0;
assign EZ_WAKEUP                =  1'b0;



assign UART_TXD                 =  1'b1;
assign UART_PS_MODE             =  1'b1;
assign ZB_UART_TXD              =  1'b1;
assign ZB_RESET_N               =  1'b0;
assign ZB_WAKEUP                =  1'b0;
//assign GX_TXD                   =  4'b0;



//For LED result select
wire  [1:0] led_select0; //DDR test
wire  [1:0] led_select1; //SRAM test
wire  [1:0] led_select2; //FLASH test
wire  [0:0] led_blink;

assign LED_N[0] = (led_select0 == 2'b00) ? 1'b1 :
				  (led_select0 == 2'b01) ? 1'b0 :
                   led_blink;
assign LED_N[1] = (led_select1 == 2'b00) ? 1'b1 :
				  (led_select1 == 2'b01) ? 1'b0 :
                  led_blink;
assign LED_N[2] = (led_select2 == 2'b00) ? 1'b1 :
				  (led_select2 == 2'b01) ? 1'b0 :
                  led_blink;

	//Using LED BLINK 
	LED_BLINK LED_BLINK (
		.clk(pll_clk100m),
		.rstb(PUSHSW_N[0]),
		.led_0(led_blink)
	);

assign TSE_RESET_N = pll_locked;

endmodule

//LED blink circuit
module LED_BLINK( clk, rstb, led_0);
	input clk;    //clk 40MHz
	input rstb;   //reset_b
	output led_0; //led control 0:on 1:off
	reg  led_0;
    
	reg  [25:0] led_cnt;

    parameter led_cnt_1s = 26'd49999999; //1S CLK=50MHz
      //parameter led_cnt_1s = 26'd3999; //sim用パラメータ

	//カウンタ   
	always @ (posedge clk or negedge rstb )
		if (rstb==1'b0)
			led_cnt <= 26'b0;
		else if (led_cnt == led_cnt_1s) //1秒経過 
			led_cnt <= 26'b0;             //カウント値を0
		else
			led_cnt <= led_cnt + 26'd1;   //カウントアップ
      
    //LED制御
	always @ (posedge clk or negedge rstb )
		if (rstb==1'b0) 
			led_0 <= 1'b0;
		else if (led_cnt == led_cnt_1s ) 
			led_0 <= ~led_0;              //LED反転
		else
			led_0 <= led_0;
			
			


			
endmodule


